﻿Public Class DataProvider

    'the number of rows in our dataset (we're going to generate them on the fly, since it's not real data)
    Dim numberOfRowsToCreate = 2000

    Public Function GetDataSet(ByVal firstRow As Integer, ByVal numberOfRows As Integer) As DataSet
        ' 'retrieve' required data

        'create a DataSet to return, with one table
        Dim ds As New DataSet
        Dim table As New DataTable
        Dim data(2) As Object
        Dim i As Int32
        Dim r As New Random
        ds.Tables.Add(table)

        '3 basic columns
        table.Columns.Add("id", i.GetType)
        table.Columns.Add("test")
        table.Columns.Add("random")

        'if the indexer is asking for rows that don't exist in our source (or in this 
        'example, we wont create) then return nothing to tell it to stop.
        If firstRow >= numberOfRowsToCreate Then Return Nothing

        'generate the data requested, fill in the rows with made up data
        While firstRow + i < numberOfRowsToCreate And i < numberOfRows
            data(0) = i + firstRow
            data(1) = "This is row number " & i
            data(2) = r.Next(999999)

            table.Rows.Add(data)
            i = i + 1
        End While

        'return the dataset to the indexer
        Return ds
    End Function
End Class
